backsolve {base} | R Documentation

## Solve an Upper or Lower Triangular System

### Description

Solves a triangular system of linear equations.

### Usage

       backsolve(r, x, k = ncol(r), upper.tri = TRUE,
                 transpose = FALSE)
    forwardsolve(l, x, k = ncol(l), upper.tri = FALSE,
                 transpose = FALSE)

### Arguments

`r, l` | an upper (or lower) triangular matrix giving the coefficients for the system to be solved. Values below (above) the diagonal are ignored.
`x` | a matrix whose columns give the right-hand sides for the equations.
`k` | The number of columns of `r` and rows of `x` to use.
`upper.tri` | logical; if `TRUE` (default), the upper triangular part of `r` is used. Otherwise, the lower one.
`transpose` | logical; if `TRUE`, solve r' * y = x for y, i.e., `t(r) %*% y == x`.

### Details

Solves a system of linear equations where the coefficient matrix is upper (or ‘right’, ‘R’) or lower (‘left’, ‘L’) triangular.

`x <- backsolve (R, b)` solves R x = b, and
`x <- forwardsolve(L, b)` solves L x = b, respectively.

The `r`/`l` must have at least `k` rows and columns, and `x` must have at least `k` rows.

This is a wrapper for the level-3 BLAS routine `dtrsm`.

### Value

The solution of the triangular system. The result will be a vector if `x` is a vector and a matrix if `x` is a matrix.

### References

Becker, R. A., Chambers, J. M. and Wilks, A. R. (1988) The New S Language. Wadsworth & Brooks/Cole.

Dongarra, J. J., Bunch, J. R., Moler, C. B. and Stewart, G. W. (1978) LINPACK Users Guide. Philadelphia: SIAM Publications.

### See Also

`chol`, `qr`, `solve`.

### Examples

    ## upper triangular matrix 'r':
    r <- rbind(c(1,2,3),
               c(0,1,1),
               c(0,0,2))
    ( y <- backsolve(r, x <- c(8,4,2)) ) # -1 3 1
    r %*% y # == x = (8,4,2)
    backsolve(r, x, transpose = TRUE) # 8 -12 -5

[Package base version 3.6.0 Index]